function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import { IconFont } from '@zgfe/business-lib';
import { Input, Table } from 'antd';
import React, { useEffect, useState } from 'react';
import ZModulesCDP from '../../../../../types';
import { ColumnCell } from '../compareTable';
import { columnNameReg } from '../row2Column/columnName';
var Preview = function Preview(_ref) {
  var defaultValue = _ref.defaultValue,
    list = _ref.list,
    selected = _ref.selected,
    onChange = _ref.onChange;
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    columnList = _useState2[0],
    setColumnList = _useState2[1];
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    columnName = _useState4[0],
    setColumnName = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    columnValue = _useState6[0],
    setColumnValue = _useState6[1];
  useEffect(function () {
    if (!defaultValue) return;
    setColumnName(defaultValue.columnName);
    setColumnValue(defaultValue.columnValue);
  }, []);
  useEffect(function () {
    var nameList = selected.map(function (item) {
      return item.name;
    });
    var res = list.filter(function (item) {
      return !nameList.includes(item.name);
    });
    if (!nameList.length) {
      setColumnList([]);
    } else {
      setColumnList([{
        name: '__fix__column_name',
        comment: '',
        webType: ZModulesCDP.WebType.string,
        isPrimaryKey: false,
        type: ''
      }, {
        name: '__fix__column_value',
        comment: '',
        webType: ZModulesCDP.WebType.string,
        isPrimaryKey: false,
        type: ''
      }].concat(_toConsumableArray(res)));
    }
  }, [list, selected]);
  useEffect(function () {
    if (onChange) onChange({
      columnName: columnName,
      columnValue: columnValue
    });
  }, [columnName, columnValue]);
  return /*#__PURE__*/React.createElement(Table, {
    columns: [{
      title: '字段名称',
      dataIndex: 'name',
      render: function render(v, row) {
        if (v === '__fix__column_name') {
          return /*#__PURE__*/React.createElement(Input, {
            value: columnName,
            placeholder: "\u8BF7\u8F93\u5165\u5217\u540D\uFF08\u539F\u5B57\u6BB5\uFF09",
            addonAfter: /*#__PURE__*/React.createElement(IconFont, {
              type: "bianji"
            }),
            onChange: function onChange(e) {
              e.persist();
              if (!columnNameReg.test(e.target.value) || /\^/.test(e.target.value)) return;
              setColumnName(e.target.value);
            }
          });
        } else if (v === '__fix__column_value') {
          return /*#__PURE__*/React.createElement(Input, {
            value: columnValue,
            placeholder: "\u8BF7\u8F93\u5165\u5217\u540D\uFF08\u539F\u503C\uFF09",
            addonAfter: /*#__PURE__*/React.createElement(IconFont, {
              type: "bianji"
            }),
            onChange: function onChange(e) {
              e.persist();
              if (!columnNameReg.test(e.target.value) || /\^/.test(e.target.value)) return;
              setColumnValue(e.target.value);
            }
          });
        }
        return /*#__PURE__*/React.createElement(ColumnCell, {
          column: row
        });
      }
    }],
    rowKey: "name",
    dataSource: columnList,
    pagination: false
  });
};
export default Preview;